put_bucket_cors¶
Operation¶
put_bucket_cors
async
¶
put_bucket_cors(request: PutBucketCorsInput | PutBucketCorsInputDict, /, *, plugins: list[Plugin] | None = None) -> PutBucketCorsOutput
put_bucket_cors(*, plugins: list[Plugin] | None = None, **kwargs: Unpack[PutBucketCorsInputDict]) -> PutBucketCorsOutput
Note
This operation is not supported for directory buckets.
Sets the cors configuration for your bucket. If the configuration
exists, Amazon S3 replaces it.
To use this operation, you must be allowed to perform the
s3:PutBucketCORS action. By default, the bucket owner has this
permission and can grant it to others.
You set this configuration on a bucket so that the bucket can service
cross-origin requests. For example, you might want to enable a request
whose origin is http://www.example.com to access your Amazon S3 bucket
at my.example.bucket.com by using the browser's XMLHttpRequest
capability.
To enable cross-origin resource sharing (CORS) on a bucket, you add the
cors subresource to the bucket. The cors subresource is an XML
document in which you configure rules that identify origins and the HTTP
methods that can be executed on your bucket. The document is limited to
64 KB in size.
When Amazon S3 receives a cross-origin request (or a pre-flight OPTIONS
request) against a bucket, it evaluates the cors configuration on the
bucket and uses the first CORSRule rule that matches the incoming
browser request to enable a cross-origin request. For a rule to match,
the following conditions must be met:
-
The request's
Originheader must matchAllowedOriginelements. -
The request method (for example, GET, PUT, HEAD, and so on) or the
Access-Control-Request-Methodheader in case of a pre-flightOPTIONSrequest must be one of theAllowedMethodelements. -
Every header specified in the
Access-Control-Request-Headersrequest header of a pre-flight request must match anAllowedHeaderelement.
For more information about CORS, go to Enabling Cross-Origin Resource Sharing in the Amazon S3 User Guide.
The following operations are related to PutBucketCors:
Warning
You must URL encode any signed header values that contain spaces. For
example, if your header value is my file.txt, containing two spaces
after my, you must URL encode this value to my%20%20file.txt.
Parameters:
| Name | Type | Description | Default |
|---|---|---|---|
plugins
|
list[Plugin] | None
|
A list of callables that modify the configuration dynamically. Changes made by these plugins only apply for the duration of the operation execution and will not affect any other operation invocations. |
None
|
Returns:
| Type | Description |
|---|---|
PutBucketCorsOutput
|
An instance of |
Input¶
Pass the input fields as keyword arguments, or pass a model or dictionary as the first positional argument. Pass plugins separately as a keyword argument.
Model¶
PutBucketCorsInput
dataclass
¶
Bases: _SerdeShape
Dataclass for PutBucketCorsInput structure.
Attributes¶
bucket
class-attribute
instance-attribute
¶
bucket: str | None = ...
Specifies the bucket impacted by the corsconfiguration.
checksum_algorithm
class-attribute
instance-attribute
¶
checksum_algorithm: str | None = ...
Indicates the algorithm used to create the checksum for the request when
you use the SDK. This header will not provide any additional
functionality if you don't use the SDK. When you send this header,
there must be a corresponding x-amz-checksum or x-amz-trailer header
sent. Otherwise, Amazon S3 fails the request with the HTTP status code
400 Bad Request. For more information, see Checking object
integrity
in the Amazon S3 User Guide.
If you provide an individual checksum, Amazon S3 ignores any provided
ChecksumAlgorithm parameter.
content_md5
class-attribute
instance-attribute
¶
content_md5: str | None = ...
The Base64 encoded 128-bit MD5 digest of the data. This header must be
used as a message integrity check to verify that the request body was
not corrupted in transit. For more information, go to RFC
1864.
For requests made using the Amazon Web Services Command Line Interface (CLI) or Amazon Web Services SDKs, this field is calculated automatically.
cors_configuration
class-attribute
instance-attribute
¶
cors_configuration: CORSConfiguration | None = ...
Describes the cross-origin access configuration for objects in an Amazon S3 bucket. For more information, see Enabling Cross-Origin Resource Sharing in the Amazon S3 User Guide.
expected_bucket_owner
class-attribute
instance-attribute
¶
expected_bucket_owner: str | None = ...
The account ID of the expected bucket owner. If the account ID that you
provide does not match the actual owner of the bucket, the request fails
with the HTTP status code 403 Forbidden (access denied).
Dictionaries¶
PutBucketCorsInputDict
¶
Bases: TypedDict
Dictionary form of PutBucketCorsInput.
Attributes¶
bucket
instance-attribute
¶
Specifies the bucket impacted by the corsconfiguration.
checksum_algorithm
instance-attribute
¶
checksum_algorithm: str | None
Indicates the algorithm used to create the checksum for the request when
you use the SDK. This header will not provide any additional
functionality if you don't use the SDK. When you send this header,
there must be a corresponding x-amz-checksum or x-amz-trailer header
sent. Otherwise, Amazon S3 fails the request with the HTTP status code
400 Bad Request. For more information, see Checking object
integrity
in the Amazon S3 User Guide.
If you provide an individual checksum, Amazon S3 ignores any provided
ChecksumAlgorithm parameter.
content_md5
instance-attribute
¶
content_md5: str | None
The Base64 encoded 128-bit MD5 digest of the data. This header must be
used as a message integrity check to verify that the request body was
not corrupted in transit. For more information, go to RFC
1864.
For requests made using the Amazon Web Services Command Line Interface (CLI) or Amazon Web Services SDKs, this field is calculated automatically.
cors_configuration
instance-attribute
¶
cors_configuration: Required[CORSConfiguration | CORSConfigurationDict]
Describes the cross-origin access configuration for objects in an Amazon S3 bucket. For more information, see Enabling Cross-Origin Resource Sharing in the Amazon S3 User Guide.
Output¶
PutBucketCorsOutput
dataclass
¶
Bases: _SerdeShape
Dataclass for PutBucketCorsOutput structure.